var contextsearch = {

  load: function() {

    contextsearch.contextitem = document.getElementById("context-searchmenu");

    try {
      
      document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",contextsearch.popuphandler,false);
      
    }
    
    catch(e) {}
  
  },
  
  popuphandler : function() {

    document.getElementById("context-searchselect").hidden = "true";
          
    if (gContextMenu.isTextSelected) {
    
      var text = gContextMenu.searchSelected();
      if (text.length > 15) text = text.substr(0,15) + "...";
      
      text = gNavigatorBundle.getFormattedString("searchText", [text]);
      
      contextsearch.contextitem.setAttribute("label", text);
      contextsearch.contextitem.setAttribute("hidden","false");
          
    }
    
    else {
    
      contextsearch.contextitem.setAttribute("hidden","true");
    
    }
       
  },
  
  search : function(aEvent) {
  
    if (!aEvent.target.id)
      return;
  
    var searchUrl = contextsearch.geturl(aEvent.target.id, gContextMenu.searchSelected()); 
    
    if (aEvent.shiftKey) {
    
      openNewWindowWith(searchUrl);
    
    }    
      
    else {
    
      var newTab = getBrowser().addTab(searchUrl);
      if (aEvent.ctrlKey) window.getBrowser().selectedTab = newTab;
      
    }
    
  },
  
  geturl: function(searchEngine,searchValue) {
  
  	var iSearchService = Components.classes['@mozilla.org/rdf/datasource;1?name=internetsearch']
  	                       .getService(Components.interfaces.nsIInternetSearchService);
  	                       
  	var searchUrl = iSearchService.GetInternetSearchURL(searchEngine, encodeURIComponent(searchValue), 0, 0, {value: 0});
  	
  	if (!searchValue) {
  	
  		var uri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
  		uri.spec = searchUrl;
  		searchUrl = uri.host;
  		
    }
    
  	return searchUrl;
	
	}
	
}

window.addEventListener("load",contextsearch.load,true);